unit ObjetosGL;

interface

uses OpenGL, Math;

type
  TVet3d = array [1..3] of real;

  TCursor3D = record
    p,v,a: Tvet3d;
//    pAnt: Tvet3d;
    aAnt: Tvet3d;
    ang: Tvet3d;
    angt,angf: real;
    t, tAnt: real;
    size: real;
  end;

procedure Eixos(s: real; simetrico: boolean);
procedure Cursor3D(c: TCursor3D);
procedure Grade(tamQuad: real; quant: integer);
procedure DesenhaChao(tamQuadX, tamQuadY: real; quant: integer);
procedure CoordenadasGrade(p: Tvet3d);

implementation

const
  AngSetaCursor = 10;
  TamanhoSetaCursor = 1/3;

procedure Eixos(s: real; simetrico: boolean);
var f,t: real;
begin
  f := s;
  if simetrico
    then t := -s
    else t := -s/10;
  glBegin(GL_LINES);
    glcolor3f(1,0,0); glVertex3f(t,0,0); glVertex3f(f,0,0);
    glcolor3f(0,1,0); glVertex3f(0,t,0); glVertex3f(0,f,0);
    glcolor3f(0,0,1); glVertex3f(0,0,t); glVertex3f(0,0,f);
  glEnd;
end;

procedure Seta(s: real);
begin
  glPushMatrix;
  glBegin(GL_LINES);
     glVertex3f(-s,0,0);
     glVertex3f(+s,0,0);
  glEnd;
  glBegin(GL_TRIANGLES);
     glVertex3f(+s,0,0);
     glVertex3f((+s*(1-TamanhoSetaCursor))*cos(DegToRad(AngSetaCursor)),(+s*(1-TamanhoSetaCursor))*sin(DegToRad(AngSetaCursor)),0);
     glVertex3f((+s*(1-TamanhoSetaCursor))*cos(DegToRad(-AngSetaCursor)),(+s*(1-TamanhoSetaCursor))*sin(DegToRad(-AngSetaCursor)),0);
     glVertex3f(+s,0,0);
     glVertex3f((+s*(1-TamanhoSetaCursor))*cos(DegToRad(AngSetaCursor)),0,(+s*(1-TamanhoSetaCursor))*sin(DegToRad(AngSetaCursor)));
     glVertex3f((+s*(1-TamanhoSetaCursor))*cos(DegToRad(-AngSetaCursor)),0,(+s*(1-TamanhoSetaCursor))*sin(DegToRad(-AngSetaCursor)));
  glEnd;
  glPopMatrix;
end;

procedure Cursor3D(c: TCursor3D);
begin
glPushMatrix;

  glLoadIdentity;
  glTranslate(c.p[1], c.p[2], c.p[3]);
  glRotate(c.ang[1],1,0,0);
  glRotate(c.ang[2],0,1,0);
  glRotate(c.ang[3],0,0,1);

  glcolor3f(1,0,0); Seta(c.size); glRotate(90,0,0,1);
  glcolor3f(0,1,0); Seta(c.size); glRotate(-90,0,1,0);
  glcolor3f(0,0,1); Seta(c.size);

glPopMatrix
end;

procedure Grade(tamQuad: real; quant: integer);
procedure quadrado(quant: integer);
var i,j: integer;
begin
for i := -quant to quant-1 do
  for j := -quant to quant-1 do
    begin
    glbegin(GL_LINE_LOOP);
      glVertex3f(i,j,quant);
      glVertex3f(i+1,j,quant);
      glVertex3f(i+1,j+1,quant);
      glVertex3f(i,j+1,quant);
    glend;
    end;
end;

begin
glColor3f(0.5,1,0.5);
glPushMatrix;
glScale(tamQuad,tamQuad,tamQuad);
quadrado(quant);
glRotate(90,1,0,0); quadrado(quant);
glRotate(90,1,0,0); quadrado(quant);
glRotate(90,1,0,0); quadrado(quant);
glRotate(90,0,1,0); quadrado(quant);
glRotate(180,0,1,0); quadrado(quant);
glPopMatrix;
end;

procedure CoordenadasGrade(p: Tvet3d);
begin
glPushMatrix;
{glBegin(GL_LINES);
  glColor3f(1,0,0);  glVertex3f(x-tamQ*quant,0,0); glVertex3f(x+tamQ*quant,0,0);
  glColor3f(0,0.5,0);glVertex3f(0,y-tamQ*quant,0); glVertex3f(0,y+tamQ*quant,0);
  glColor3f(0,0,1);  glVertex3f(0,0,z-tamQ*quant); glVertex3f(0,0,z+tamQ*quant);
glEnd;}

glPointSize(5);
glBegin(GL_POINTS);
  glColor3f(1,0,0); glVertex3f(-p[1],0,0);
  glColor3f(0,1,0); glVertex3f(0,-p[2],0);
  glColor3f(0,0,1); glVertex3f(0,0,-p[3]);
glEnd;

glColor3f(0,0.5,0);
glBegin(GL_LINE_LOOP);
  glVertex3f(0,0,0); glVertex3f(-p[1],0,0); glVertex3f(-p[1],-p[2],0); glVertex3f(0,-p[2],0);
glEnd;
glBegin(GL_LINE_LOOP);
  glVertex3f(0,0,-p[3]); glVertex3f(-p[1],0,-p[3]); glVertex3f(-p[1],-p[2],-p[3]); glVertex3f(0,-p[2],-p[3]);
glEnd;
glEnd;
glBegin(GL_LINE_LOOP);
  glVertex3f(0,0,0); glVertex3f(-p[1],0,0); glVertex3f(-p[1],0,-p[3]); glVertex3f(0,0,-p[3]);
glEnd;
glBegin(GL_LINE_LOOP);
  glVertex3f(0,-p[2],0); glVertex3f(-p[1],-p[2],0); glVertex3f(-p[1],-p[2],-p[3]); glVertex3f(0,-p[2],-p[3]);
glEnd;
glBegin(GL_LINE_LOOP);
  glVertex3f(0,0,0); glVertex3f(0,-p[2],0); glVertex3f(0,-p[2],-p[3]); glVertex3f(0,0,-p[3]);
glEnd;
glBegin(GL_LINE_LOOP);
  glVertex3f(-p[1],0,0); glVertex3f(-p[1],-p[2],0); glVertex3f(-p[1],-p[2],-p[3]); glVertex3f(-p[1],0,-p[3]);
glEnd;


glPopMatrix;
end;


procedure DesenhaChao(tamQuadX, tamQuadY: real; quant: integer);
var i,j,c: integer;
begin
glEnable(GL_BLEND);
glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

glPushMatrix;
  quant := quant div 2;
  glScale(tamQuadX,tamQuadY,1);
  for i := -quant to quant-1 do
    for j := -quant to quant-1 do
      for c := 1 to 2 do
        begin
        if c = 1 then
          begin
          // grade
          glColor3f(0,1,0);
          glbegin(GL_LINE_LOOP);
          end
          else
          begin
          // preenchimento
          glColor4f(0.3,1,0.3,0.5);
          glbegin(GL_QUADS);
          end;
          glVertex3f(i,j,0);
          glVertex3f(i+1,j,0);
          glVertex3f(i+1,j+1,0);
          glVertex3f(i,j+1,0);
          glend;
        end;
glPopMatrix;
glDisable(GL_BLEND);

// desenha eixos
glEnable(GL_LINE_WIDTH);
glLineWidth(8);
glBegin(GL_LINES);
  glColor3f(1,0,0);
  glVertex3f(-tamQuadX*quant,0,0);
  glVertex3f(+tamQuadX*quant,0,0);
  glColor3f(0,1,0);
  glVertex3f(0,-tamQuadY*quant,0);
  glVertex3f(0,+tamQuadY*quant,0);
glEnd;
glLineWidth(1);


end;


end.
