unit UArquivoCena;

interface

uses
  SysUtils, Forms, DB, DBClient, DBCtrls;

procedure CriaBancoDeDados(var cds: TClientDataSet);
procedure AbrirCena(cds: TClientDataSet; FileName: string);



implementation

procedure CriaBancoDeDados(var cds: TClientDataSet);
procedure CriaCampo(var cds: TClientDataSet; nome: string; Tipo: TFieldType; tamanho: integer=50);
var field: TField;
begin
  with cds do
    begin
    case Tipo of
      ftString:
        begin
        Field := TStringField.Create(cds);
        Field.Size := tamanho;
        end;
      ftInteger: Field := TIntegerField.Create(cds);
      ftFloat: Field := TFloatField.Create(cds);
      ftBoolean: Field := TBooleanField.Create(cds);
    end;

    with Field do
      begin
      FieldName := Nome;
      Name := 'ClientDataSet1' + FieldName;
      FieldKind := fkData;
      DataSet := cds;
      end;
    end;
end;

begin
  with cds do
    begin
    CriaCampo(cds,'Nome',ftString,20);
    CriaCampo(cds,'ID',ftInteger);
    CriaCampo(cds,'X',ftFloat);
    CriaCampo(cds,'Y',ftFloat);
    CriaCampo(cds,'Z',ftFloat);
    CriaCampo(cds,'Ang',ftFloat);
    CriaCampo(cds,'eixoX',ftFloat);
    CriaCampo(cds,'eixoY',ftFloat);
    CriaCampo(cds,'eixoZ',ftFloat);
    CriaCampo(cds,'SX',ftFloat);
    CriaCampo(cds,'SY',ftFloat);
    CriaCampo(cds,'SZ',ftFloat);
                                   // esf  | caixa | plano | cap  |
    CriaCampo(cds,'Dim1',ftFloat); // raio | LadoX |   a   | raio |
    CriaCampo(cds,'Dim2',ftFloat); //      | LadoY |   b   | comp |
    CriaCampo(cds,'Dim3',ftFloat); //      | LadoZ |   c   |      |
    CriaCampo(cds,'Dim4',ftFloat); //      |       |   d   |      |
    CriaCampo(cds,'Massa',ftFloat);
    CriaCampo(cds,'R',ftFloat);
    CriaCampo(cds,'G',ftFloat);
    CriaCampo(cds,'B',ftFloat);
    CriaCampo(cds,'A',ftFloat);
    CriaCampo(cds,'UsaCor',ftBoolean);
    CriaCampo(cds,'Arquivo',ftString,255);
    CriaCampo(cds,'UserMove',ftBoolean);
    CriaCampo(cds,'ODEMove',ftBoolean);
    CriaCampo(cds,'MoveX',ftBoolean);
    CriaCampo(cds,'MoveY',ftBoolean);
    CriaCampo(cds,'MoveZ',ftBoolean);
    CriaCampo(cds,'ODETipo',ftInteger);
    CriaCampo(cds,'MostraRastroSempre',ftBoolean);
    CriaCampo(cds,'MostraRastroSolto',ftBoolean);
    CriaCampo(cds,'MostraVecV',ftBoolean);
    CriaCampo(cds,'MostraVecA',ftBoolean);
    CriaCampo(cds,'MostraEixoRot',ftBoolean);
    CriaCampo(cds,'TipoDeColisao',ftInteger);
    CriaCampo(cds,'Atrito',ftFloat);
    CriaCampo(cds,'TemGravidade',ftBoolean);


    CreateDir(ExtractFilePath(Application.ExeName) + 'Cenas');
    DeleteFile(ExtractFilePath(Application.ExeName) + 'Cenas\temp.xml');
    FileName := ExtractFilePath(Application.ExeName) + 'Cenas\temp.xml';
    CreateDataSet;
    Active := true;
    end;
end;


procedure AbrirCena(cds: TClientDataSet; FileName: string);
begin
  cds.Active := false;
  cds.FileName := FileName;
  cds.Active := true;
end;

end.
