unit UConfiguraGL;

interface

uses OpenGL, windows;

var
  glDC: HDC;
  GLContext: HGLRC;

procedure ConfiguraOpenGL(Handle:HWND);
procedure FinalizaOpenGL();

implementation

procedure ConfiguraOpenGL(Handle:HWND);
var pfd: TPixelFormatDescriptor;
    FormatIndex: integer;
begin
fillchar(pfd,SizeOf(pfd),0);

{configura as caractersticas do formato dos pixels}
with pfd do
  begin
  nSize := SizeOf(pfd);          {define o tamanho da estrutura}
  nVersion := 1;                 {a verso atual do descritor  1}
  dwFlags := PFD_DRAW_TO_WINDOW or PFD_DOUBLEBUFFER;
  iPixelType := PFD_TYPE_RGBA;
  cColorBits := 24;              {suporta 24 bits de cores}
  cDepthBits := 32;              {32 bits de profundidade do eixo Z}
  iLayerType := PFD_MAIN_PLANE;
  end;
glDC := getDC(Handle);           {Associa o Device Context com o glDC}
FormatIndex := ChoosePixelFormat(glDC,@pfd); {mapeamento}

{ajusta as caractersticas dos pixels seguindo as configuraes acima}
SetPixelFormat(glDC,FormatIndex,@pfd);

{permite que as configuraes dos pixels sejam aplicadas ao glDC}
GLContext:=wglCreateContext(glDC);
wglMakeCurrent(glDC,GLContext);  

  // Black Background
  glClearColor(0.0, 0.0, 0.0, 0.0);

  // Enables Smooth Color Shading
  glShadeModel(GL_SMOOTH);

  // Depth Buffer Setup
  glClearDepth(1.0);

  // Enable Depth Buffer
  glEnable(GL_DEPTH_TEST);

  // The Type Of Depth Test To Do
  glDepthFunc(GL_LESS);

  //Realy Nice perspective calculations
  glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);

  // backface culling
  glDisable(GL_CULL_FACE);


end;


procedure FinalizaOpenGL();
begin
{o valor ZERO, indica que este contexto no ser mais utilizado}
wglMakeCurrent(glDC,0);
{aps isso  permitido excluir este contexto}
wglDeleteContext(GLContext);
end;

end.
